/*
 * Copyright (c) 2020-2040, 北京符节科技有限公司 (support@fujieid.com & https://www.fujieid.com).
 * <p>
 * Licensed under the GNU LESSER GENERAL PUBLIC LICENSE 3.0;
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * <p>
 * http://www.gnu.org/licenses/lgpl.html
 * <p>
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.fujieid.jap.core.cache;

import java.util.concurrent.TimeUnit;

/**
 * Configuration of {@link com.fujieid.jap.core.cache.JapCache}
 *
 * @author yadong.zhang (yadong.zhang0415(a)gmail.com)
 * @version 1.0.0
 * @since 1.0.0
 */
public class JapCacheConfig {

    /**
     * The cache expiration time is 1 day by default
     */
    public static long timeout = TimeUnit.DAYS.toMillis(7);

    /**
     * Turn on the timed task of clearing the local memory cache.
     * After it is turned on, the {@link JapLocalCache#pruneCache()} method will be called to automatically clear the cache.
     * If you customize the implemented jap cache interface, you can ignore this config.
     */
    public static boolean schedulePrune = true;
}
